
import time
from PyQt5 import Qt
qt = Qt


class MultiImageAnimatedIcon(qt.QObject):
    iconChanged = qt.pyqtSignal(qt.QIcon)
    def __init__(self, parent=None):
        qt.QObject.__init__(self, parent)


class _Wrapper(qt.QRunnable):
    def __init__(self, signalHolder):
        super(_Wrapper, self).__init__()
        self.__signalHolder = signalHolder

    def run(self):
        print("RUNNER STARTED")
        holder = self.__signalHolder
        try:
            pass
        finally:
            holder.finished.emit()
            print("RUNNER FINISHED")

    def autoDelete(self):
        return True


class ThreadPoolPushButton(qt.QPushButton):

    finished = qt.pyqtSignal()

    def __init__(self, parent=None, text=None, icon=None):
        qt.QPushButton.__init__(self, parent)
        self.__waiting = False
        self.__waitingIcon = MultiImageAnimatedIcon()
        self.__runnerCount = 0
        self.finished.connect(self.__runnerFinished)

    def __setIcon(self, icon):
        qt.QPushButton.setIcon(self, icon)

    def setWaiting(self, waiting):
        if self.__waiting == waiting:
            return
        self.__waiting = waiting

        if self.__waiting:
            self.__waitingIcon.iconChanged.connect(self.__setIcon)
        else:
            self.__waitingIcon.iconChanged.disconnect(self.__setIcon)

    def executeCallable(self):
        self.__runnerStarted()
        runner = _Wrapper(self)
        qt.QThreadPool.globalInstance().start(runner)

    def __runnerStarted(self):
        self.__runnerCount += 1
        if self.__runnerCount > 0:
            self.setWaiting(True)

    def __runnerFinished(self):
        self.__runnerCount -= 1
        if self.__runnerCount <= 0:
            self.setWaiting(False)
            print("NO MORE RUNNERS")


qapp = qt.QApplication([])
button = ThreadPoolPushButton()
button.executeCallable()
time.sleep(1)
qapp.processEvents()
print("END")

